<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'DevOpsLifeCycle',
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      slides: this.data.stages,
      scrubberValue: 0,
      dragging: false,
      initialValue: 0,
      initialPosition: 0,
      constraintWidth: 0,
      slideBreakpoints: [],
      activeSlide: 0,
    };
  },
  watch: {
    scrubberValue(): void {
      const currentSlide = this.slideBreakpoints.findIndex(
        ({ left, right }) =>
          this.scrubberValue > left && this.scrubberValue <= right,
      );
      if (currentSlide !== -1) {
        this.activeSlide = currentSlide;
      }
    },
  },
  mounted() {
    this.constraintWidth = this.$refs.timelineBackground?.offsetWidth;
    this.calculateBreakpoints();
    this.setActiveSlide(2);
  },
  methods: {
    calculateBreakpoints() {
      this.slideBreakpoints = this.$refs.stages?.map((stage) => ({
        left: stage.offsetLeft,
        center: Math.floor(stage.offsetLeft + stage.offsetWidth / 2),
        right: stage.offsetLeft + stage.offsetWidth,
      }));
    },
    setActiveSlide(slideIndex) {
      this.scrubberValue = this.slideBreakpoints[slideIndex].center;
      this.activeSlide = slideIndex;
      this.moveSlider();
    },
    moveSlider() {
      // move the slider", essentially just change the width of the brighter bar.
      this.$refs.timelineBar.style.width = `${this.scrubberValue}px`;
      this.$refs.timelineDot.style.left = `${this.scrubberValue}px`;
    },
    dragStart(event) {
      this.dragging = true;
      this.initialPosition = event.clientX;
      this.initialValue = this.scrubberValue;
      document.addEventListener('mousemove', this.handleMouseMove);
      document.addEventListener('mouseup', this.handleMouseUp);
    },
    handleMouseMove(event) {
      // scrub if the mouse is being pressed
      if (this.dragging) {
        const newValue =
          this.initialValue + (event.clientX - this.initialPosition);

        // constrain the value to the min/max
        this.scrubberValue = this.constrain(newValue);
        this.moveSlider();
      }
    },
    handleMouseUp() {
      // disable dragging
      this.dragging = false;
      this.setActiveSlide(this.activeSlide);
      document.removeEventListener('mousemove', this.handleMouseMove);
      document.removeEventListener('mouseup', this.handleMouseUp);
    },
    scrubberJump(event) {
      this.scrubberValue =
        event.clientX - this.$refs.timelineBackground.getBoundingClientRect().x;
      this.moveSlider();
      this.dragStart(event);
    },
    constrain(value) {
      return Math.min(Math.max(parseInt(value, 10), 1), this.constraintWidth);
    },
  },
});
</script>

<template>
  <div class="lifecycle">
    <SlpContainer>
      <SlpTypography
        class="slp-mb-8 devops-header"
        variant="heading2-bold"
        tag="h2"
      >
        {{ data.title }}
      </SlpTypography>
      <SlpTypography
        class="slp-mb-24 devops-subheader"
        variant="heading5"
        tag="p"
      >
        {{ data.tagline }}
      </SlpTypography>
      <SlpRow
        :id="`${slides[activeSlide].title.toLowerCase()}-content`"
        class="slp-my-64"
        role="tabpanel"
        :aria-labelledby="`${slides[activeSlide].title.toLowerCase()}-tab`"
        aria-live="polite"
      >
        <SlpColumn
          :cols="6"
          class="devops-content"
          :data-ga-carousel="slides[activeSlide].ga_carousel_value"
        >
          <SlpIcon
            v-if="slides[activeSlide].icon"
            class="devops_icon slp-mb-16"
            :name="slides[activeSlide].icon.name"
            :variant="slides[activeSlide].icon.variant"
            :alt="slides[activeSlide].icon.alt"
            size="lg"
            slp-color="primary-300"
          />
          <SlpTypography class="slp-mb-16" variant="heading3-bold" tag="h3">
            {{ slides[activeSlide].title }}
          </SlpTypography>
          <div
            class="slp-mb-16 tagline"
            v-html="$md.render(slides[activeSlide].tagline)"
          ></div>
          <SlpTypography class="slp-mb-32" variant="body2" tag="p">
            {{ slides[activeSlide].description }}
          </SlpTypography>
          <SlpButton
            :href="slides[activeSlide].link.url"
            class="learn-more"
            variant="primary"
            :data-ga-name="slides[activeSlide].link.ga_name"
            data-ga-location="devops lifecycle"
          >
            {{ slides[activeSlide].link.text }}
          </SlpButton>
          <SlpButton
            variant="ghost"
            href="/why-gitlab/#sdlc-features"
            class="view-sdlc"
            :data-ga-name="`why gitlab sdlc table - ${slides[activeSlide].title}`"
            data-ga-location="devops lifecycle"
          >
            See all stages
            <SlpIcon
              class="learn-more__icon"
              name="chevron-lg-right"
              variant="product"
              alt="Chevron Right Icon"
            />
          </SlpButton>
        </SlpColumn>
        <SlpColumn :cols="6">
          <nuxt-img
            class="image"
            :src="slides[activeSlide].image"
            :alt="slides[activeSlide].alt"
            loading="lazy"
            format="webp"
            quality="99"
          />
        </SlpColumn>
      </SlpRow>
      <SlpRow>
        <SlpColumn
          class="slp-flex slp-align-items-center slp-justify-content-between timeline-container"
        >
          <div class="timeline-bar-container">
            <div
              ref="timelineBackground"
              class="timeline-bar-background"
              @mousedown="scrubberJump"
            ></div>
            <div
              ref="timelineBar"
              class="timeline-bar"
              :class="{ 'timeline-transition': !dragging }"
              @mousedown="scrubberJump"
            ></div>
            <span
              ref="timelineDot"
              class="timeline-dot"
              :class="{ 'timeline-transition': !dragging }"
              @mousedown="dragStart"
            ></span>
          </div>
          <div
            class="timeline-stages"
            role="tablist"
            aria-label="DevOps Lifecycle Stages"
          >
            <button
              v-for="(slide, index) in slides"
              :id="`${slide.title.toLowerCase()}-tab`"
              :key="slide.title"
              :ref="`stages`"
              type="button"
              role="tab"
              class="timeline-stage"
              :aria-selected="`${index == activeSlide}`"
              :aria-controls="`${slide.title.toLowerCase()}-content`"
              @click="setActiveSlide(index, $event)"
            >
              {{ slide.title }}
            </button>
          </div>
          <div class="timeline-controls">
            <SlpButton
              class="slp-mr-24"
              variant="icon"
              aria-label="View previous stage"
              :disabled="activeSlide == 0"
              @click.native="setActiveSlide(activeSlide - 1)"
            >
              <SlpIcon
                name="chevron-lg-left"
                variant="product"
                alt="Chevron Right Icon"
                slp-color="primary-100"
              />
            </SlpButton>
            <SlpButton
              variant="icon"
              aria-label="View next stage"
              :disabled="activeSlide == slides.length - 1"
              @click.native="setActiveSlide(activeSlide + 1)"
            >
              <SlpIcon
                name="chevron-lg-right"
                variant="product"
                alt="Chevron Right Icon"
                slp-color="primary-100"
              />
            </SlpButton>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.lifecycle {
  padding-top: $spacing-96;
  padding-bottom: $spacing-96;
  color: $color-text-50;
  background-color: $color-surface-700;
  display: flex;
  align-items: center;
  justify-content: center;

  &:deep p a {
    color: $color-text-50;
    text-decoration: underline;
  }
  .image {
    height: auto;
    width: 100%;
    margin: $spacing-24 0;

    @media (min-width: $breakpoint-sm) {
      padding-right: $spacing-160;
    }

    @media (min-width: $breakpoint-md) {
      margin: 0 0 $spacing-24 0;
      padding-right: 0;
      max-width: 550px;
      width: 100%;
    }
  }

  .tagline {
    font-size: $text-heading-4;
    line-height: $line-height-heading-4;
    font-weight: $font-weight-normal;
    letter-spacing: $letter-spacing-heading-4;

    @media (max-width: $breakpoint-md) {
      font-size: $text-heading-4-mobile;
      line-height: $line-height-heading-4-mobile;
      letter-spacing: $letter-spacing-heading-4-mobile;
    }
  }

  .learn-more {
    background: $color-surface-50;
    color: $color-text-300;
    transition: all 0.3s ease-in-out;
    margin-right: $spacing-8;

    &__icon {
      margin-left: $spacing-4;
      transition: transform 0.3s ease-in-out;
    }

    &:hover,
    &:active {
      background: transparent;
      color: $color-text-50;

      .learn-more__icon {
        transform: translateX($spacing-8);
      }
    }
  }

  .view-sdlc {
    color: $color-text-50;
    font-weight: $font-weight-bold;
    text-decoration: underline;
    text-underline-offset: 2px;
    text-decoration-color: transparent;
    transition: all 0.3s ease-in-out;

    &__icon {
      margin-left: $spacing-4;
      transition: transform 0.3s ease-in-out;
    }

    &:hover,
    &:active {
      text-decoration-color: $color-text-50;

      .learn-more__icon {
        transform: translateX($spacing-8);
      }
    }
  }

  .timeline-bar-background {
    position: absolute;
    cursor: pointer;
    height: 4px;
    width: 100%;
    background-color: #35296b;
    top: calc(-24px + (13px / 2 - 2px));
  }

  .timeline-transition {
    transition: all 0.3s;
  }

  .timeline-bar {
    position: absolute;
    cursor: pointer;
    height: 4px;
    width: 0;
    background: linear-gradient(90deg, #ef8cf3 0%, #825ee9 100%);
    top: calc(-24px + (13px / 2 - 2px));
  }

  .timeline-dot {
    position: absolute;
    left: calc(50% - (13px / 2));
    top: -24px;
    height: 13px;
    cursor: pointer;
    width: 13px;
    border-radius: 50%;
    background: linear-gradient(135deg, #ef8cf3 0%, #835fea 100%);
  }

  .timeline-stage {
    user-select: none;
    border: none;
    width: 100%;
    color: $color-text-50;
    font-size: $font-size-default;
    line-height: $line-height-default;

    // only give border when focus is on tab from keyboard nav
    &:focus-visible {
      border: 1px solid $color-surface-50;
      outline: -webkit-focus-ring-color auto 1px;
    }

    &:hover {
      cursor: pointer;
    }
    &:last-of-type {
      padding-right: 0;
    }
  }

  .devops_icon {
    width: 24px;
    height: 24px;
  }

  .devops-header {
    padding: $spacing-64 0 0 0;
    @media (min-width: $breakpoint-md) {
      padding: 0;
    }
  }

  .devops-subheader {
    display: none;
    @media (min-width: $breakpoint-md) {
      display: block;
    }
  }
  .devops-content {
    -webkit-user-drag: none;
    -khtml-user-drag: none;
    -moz-user-drag: none;
    -o-user-drag: none;
    user-drag: none;
    @media (min-width: $breakpoint-md) {
      padding-right: $spacing-96;
    }

    @media (min-width: 850px) {
      padding-right: $spacing-160;
    }
  }

  .timeline-container {
    position: relative;
  }

  .timeline-controls {
    bottom: $spacing-16;
    left: 50%;
    position: absolute;
    transform: translateX(-50%);
    width: $spacing-96;
    @media (min-width: $breakpoint-md) {
      bottom: $spacing-64;
      left: auto;
      right: -$spacing-16;
      transform: translate(0);
    }
    @media (min-width: $breakpoint-lg) {
      bottom: 0;
      margin-left: $spacing-24;
      position: relative;
      right: 0;
    }
  }

  .timeline-stages {
    display: flex;
    flex: 1 1 auto;
    justify-content: space-between;
    margin: 0 auto 0 0;
    -webkit-user-drag: none;
    -khtml-user-drag: none;
    -moz-user-drag: none;
    -o-user-drag: none;
    user-drag: none;
    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }
  .timeline-bar-container {
    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }
}
</style>
